SystemOrganization addCategory: #'UnixMetaStack-Profiling'!
SystemOrganization addCategory: #'UnixMetaStack-Profiling-Zen'!

TestCase subclass: #TestExampleExperimentScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestExampleExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 13:42'!
testRun

	| script |
	script := ExampleExperimentScript new run.
	self assert: (script vanillaFile ~= nil).
	self assert: (script profileFile ~= nil).
	self assert: (script extendedProfileFile ~= nil).! !

TestCase subclass: #TestExperiment
	instanceVariableNames: 'experiment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 17:16'!
setUp

	| aSetUp |
	super setUp.
	aSetUp := ProfilingExperimentSetUp new.
	experiment := ((self testedClass newWith: (aSetUp evalStringForCategory: aSetUp class greenTrainingCategories first) times: 2) targetImage: 'Pharo-20628.image') run.! !

!TestExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:53'!
testSanity

	experiment sanityCheck.
	experiment inspect.! !

!TestExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:21'!
testedClass

	^ ExtendedProfileExperiment! !

TestCase subclass: #TestProfilingExperimentSetUp
	instanceVariableNames: 'experiment setUpVanilla setUpProfiling setUpExtendedProfiling vanillaFile profileFile extendedProfileFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 17:15'!
setUp

	setUpVanilla := ((ProfilingExperimentSetUp 
						newWith: #testCategories 
						forExperimentClass: VanillaExperiment 
						withNumberOfRunsPerCategory: 2) targetImage: 'Pharo-20628.image') run.
	setUpProfiling := ((ProfilingExperimentSetUp 
						newWith: #testCategories 
						forExperimentClass: ProfileExperiment 
						withNumberOfRunsPerCategory: 2) targetImage: 'Pharo-20628.image') run.
	setUpExtendedProfiling := ((ProfilingExperimentSetUp 
									newWith: #testCategories 
									forExperimentClass: ExtendedProfileExperiment 
									withNumberOfRunsPerCategory: 2) targetImage: 'Pharo-20628.image') run.
									
	setUpProfiling slowDownFrom: setUpVanilla.
	setUpExtendedProfiling slowDownFrom: setUpVanilla.! !

!TestProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 18:21'!
testExportImportSanity

	
	vanillaFile := setUpVanilla exportToFuel.
	setUpVanilla exportToCsv.
	profileFile := setUpProfiling exportToFuel.
	setUpProfiling exportToCsv.
	extendedProfileFile := setUpExtendedProfiling exportToFuel.
	setUpExtendedProfiling exportToCsv.
	
	setUpVanilla := ProfilingExperimentSetUp importFromFuelFileName: vanillaFile.
	setUpProfiling := ProfilingExperimentSetUp importFromFuelFileName: profileFile.
	setUpExtendedProfiling := ProfilingExperimentSetUp importFromFuelFileName: extendedProfileFile.
	
	(FileSystem workingDirectory / vanillaFile) delete.
	(FileSystem workingDirectory / profileFile) delete.
	(FileSystem workingDirectory / extendedProfileFile) delete.
	
	! !

TestCase subclass: #TestRun
	instanceVariableNames: 'run failedRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 16:17'!
setUp

	run := ((self testedClass newWith: '3+4') targetImage: 'Pharo-20628.image') run.
	failedRun := ((self testedClass newWith: '#@$@#%@') targetImage: 'Pharo-20628.image') run.! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:30'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 16:19'!
testOSProcessOutput
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (run instVarNamed: 'rawOutput') = '7
'! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 20:37'!
testSanity

	run sanityCheck.! !

!TestRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:39'!
testedClass

	^ Run
! !

TestRun subclass: #TestVanillaExperimentRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

TestVanillaExperimentRun subclass: #TestProfileExperimentRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

TestProfileExperimentRun subclass: #TestExtendedProfileExperimentRun
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 16:55'!
setUp

	| aSetUp eval |
	aSetUp := ProfilingExperimentSetUp new.
	eval := aSetUp evalStringForCategory: aSetUp class testCategories first.

	run := ((self testedClass newWith: eval) targetImage: 'Pharo-20628.image') run.
	failedRun := ((self testedClass newWith: '#@$@#%@') targetImage: 'Pharo-20628.image') run.! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:58'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:18'!
testOSProcessOutput
	
	self assert: ((run instVarNamed: 'rawOutput') isKindOf: String).! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 14:09'!
testParsing
		
	super testParsing.
	self assert: ((run instVarNamed: 'byteCodes') isKindOf: Array). 
	self assert: ((run instVarNamed: 'slowPrimitives') isKindOf: Array). 
	self assert: ((run instVarNamed: 'quickPrimitives') isKindOf: Array).
	self assert: ((run instVarNamed: 'qPrimitiveCounter') isKindOf: Number).! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 19:58'!
testSanity

	super testSanity.
	run inspect.! !

!TestExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:17'!
testedClass

	^ ExtendedProfileExperimentRun! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 16:33'!
setUp

	| aSetUp eval |
	aSetUp := ProfilingExperimentSetUp new.
	eval := aSetUp evalStringForCategory: aSetUp class testCategories first.

	run := ((self testedClass newWith: eval) targetImage: 'Pharo-20628.image') run.
	failedRun := ((self testedClass newWith: '#@$@#%@') targetImage: 'Pharo-20628.image') run.! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:57'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:57'!
testOSProcessOutput
	
	self assert: ((run instVarNamed: 'rawOutput') isKindOf: String).! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:22'!
testParsing
		
	super testParsing.
	self assert: ((run instVarNamed: 'byteCodeCounter') isKindOf: Number). 
	self assert: ((run instVarNamed: 'messageCounter') isKindOf: Number). 
	self assert: ((run instVarNamed: 'primitiveCounter') isKindOf: Number).! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:58'!
testSanity

	super testSanity! !

!TestProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 10:08'!
testedClass

	^ ProfileExperimentRun! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:56'!
setUp

	super setUp! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:55'!
testFailure
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (failedRun instVarNamed: 'executedSuccessfully') =  false! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 16:20'!
testOSProcessOutput
	"use a concrete subclass of run -- mind the cr at the end"
	
	self assert: (run instVarNamed: 'rawOutput') = '7
'! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 22:09'!
testParsing

	self assert: ((run instVarNamed: 'realTime') isKindOf: Number). 
	self assert: ((run instVarNamed: 'userTime') isKindOf: Number). 
	self assert: ((run instVarNamed: 'systemTime') isKindOf: Number). ! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 21:56'!
testSanity

	super testSanity! !

!TestVanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 10:08'!
testedClass

	^ VanillaExperimentRun! !

TestCase subclass: #TestWeightedExampleExperimentScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!TestWeightedExampleExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:38'!
testRun

	| script |
	script := CoreAndAppsWeightedExampleScript new run.
	self assert: (script vanillaFile ~= nil).
	self assert: (script profileFile ~= nil).
	self assert: (script extendedProfileFile ~= nil).
	script inspect.! !

StackInterpreterPrimitives subclass: #ProfileStackInterpreter
	instanceVariableNames: ''
	classVariableNames: 'AllButExperimentalBit ExperimentalObjectBit'
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling-Zen'!

ProfileStackInterpreter subclass: #ExtendedProfileStackInterpreter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/12/2014 14:37'!
fetchNextBytecode

	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."
	
	"bytecode counters -- for analysis see p. 595 of blue book and StackInterpreter>>initializeBytecodeTableForSqueakV3PlusClosures"
	self incByteCodeCounter.
	self cppIf: MULTIPLEBYTECODESETS
		ifTrue: [currentBytecode := self fetchByte + bytecodeSetSelector]
		ifFalse: [currentBytecode := self fetchByte].! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/12/2014 14:37'!
incByteCodeCounter

	<api>
	self cCode: 'bCounter++;bArrayCounter[getCurrentBytecode()]++;'! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 18:19'!
internalExecuteNewMethod
	"regardless of whether it succeeded or not count it since it is executed"
	"for primitive Stats check StackInterpreter>>initializePrimitiveTable and StackInterpreter>>functionPointerFor: primIdx inClass: theClass"
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~= 0 ifTrue:
		[self incPrimitiveCounter.
		 self isPrimitiveFunctionPointerAnIndex ifTrue:
			[self profileQuickPrimitive. ^self internalQuickPrimitiveResponse].
		 self profileSlowPrimitive.
		 self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:16'!
printProfilingResults

	<api>
	self cCode: 'unsigned int i;'.
	self cCode: 'printf("__VM_STATS__START__{ \
	#byteCodeCounter ->%llu. \
	#messageCounter -> %llu. \
	#primitiveCounter -> %llu. \
	#qPrimitiveCounter -> %llu. \
	#sPrimitiveCounter -> %llu. \
	#otherPrimitiveCounter -> %llu. \
	#byteCode -> #( \
	",bCounter,mCounter,pCounter,qPrimitiveCounter,sPrimitiveCounter,otherPrimitiveCounter);'.
	self cCode: 'for(i=0;i<256;i++) printf("%llu\n",bArrayCounter[i])'.
	self  cCode: 'printf("). \
	#quickPrimitive -> #( \
	");'.
	self cCode: 'for(i=0;i<520;i++) printf("%llu\n",quickPrimitiveCounter[i])'.
	self cCode: 'printf("). \
	#slowPrimitive -> #( \
	");'.
	self cCode: 'for(i=0;i<576;i++) printf("%llu\n",slowPrimitiveCounter[i])'.
	self cCode: 'printf("). \
	}.__VM_STATS__END__ \
	");'.! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 14:00'!
profileQuickPrimitive

	<api>
	|index|
	index := (self cCoerce: primitiveFunctionPointer to: #sqInt). "check bounds for coercion ?"
	self cCode: 'qPrimitiveCounter++;'. "check if naming persists in translation"
	self cCode: 'quickPrimitiveCounter[index]++;'. "check if naming persists in translation"! !

!ExtendedProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 20:14'!
profileSlowPrimitive

	"check dispatchFunctionPointer: aFunctionPointer"

	<api>
	|index|
	index := -1.
	0 to: MaxPrimitiveIndex do: [ :i | ((primitiveTable at: i) == primitiveFunctionPointer ifTrue: [ index := i ]).].
	self cCode: 'if(index==-1) otherPrimitiveCounter++; else {sPrimitiveCounter++;slowPrimitiveCounter[index]++;};'.! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 11/5/2014 17:28'!
activeProcess
	"Answer the current activeProcess."
	<api> "useful for VM debugging"
	^objectMemory fetchPointer: ActiveProcessIndex ofObject: self schedulerPointer! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:21'!
commonSend
	"Send a message, starting lookup with the receiver's class."
	"Assume: messageSelector and argumentCount have been set, and that 
	the receiver and arguments have been pushed onto the stack,"
	"Note: This method is inlined into the interpreter dispatch loop."
	<sharedCodeNamed: 'commonSend' inCase: #singleExtendedSendBytecode>
	self incMessageCounter.
	super commonSend.! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:21'!
fetchNextBytecode
	"This method fetches the next instruction (bytecode). Each bytecode method is responsible for fetching the next bytecode, preferably as early as possible to allow the memory system time to process the request before the next dispatch."
	
	self incByteCodeCounter.
	self cppIf: MULTIPLEBYTECODESETS
		ifTrue: [currentBytecode := self fetchByte + bytecodeSetSelector]
		ifFalse: [currentBytecode := self fetchByte]! !

!ProfileStackInterpreter methodsFor: 'experimental-bit-accesors' stamp: 'NickPapoulias 11/6/2014 20:55'!
getExperimentalBitOf: anOop
	self inline: true.
	^((objectMemory baseHeader: anOop) bitAnd: ExperimentalObjectBit) ~= 0 ! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:20'!
incByteCodeCounter

	<api>
	self cCode: 'bCounter++;'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:20'!
incMessageCounter
	<api>
	self cCode: 'mCounter++;'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:20'!
incPrimitiveCounter
	<api>
	self cCode: 'pCounter++;'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:19'!
internalExecuteNewMethod
	"regardless of whether it succeeded or not count it since it is executed"
	| succeeded |
	<inline: true>
	primitiveFunctionPointer ~= 0 ifTrue:
		[self incPrimitiveCounter.self isPrimitiveFunctionPointerAnIndex ifTrue:
			[^self internalQuickPrimitiveResponse].
		 self externalizeIPandSP.
		 succeeded := self slowPrimitiveResponse.
		 self internalizeIPandSP.
		 succeeded ifTrue:
			[self browserPluginReturnIfNeeded.
			^nil]].
	"if not primitive, or primitive failed, activate the method"
	^self internalActivateNewMethod! !

!ProfileStackInterpreter methodsFor: 'experimental-bit-primitives' stamp: 'NickPapoulias 11/6/2014 20:57'!
primitiveGetExperimentalBit
	| rcvr hdr |
	rcvr := self stackTop.
	(self isIntegerObject: rcvr)
		ifTrue:
			[self primitiveFail ]
		ifFalse:
			[ self pop: 2. 
			self pushBool: (self getExperimentalBitOf: rcvr) ]! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 11:22'!
primitiveQuit
	self printProfilingResults.
	super primitiveQuit.! !

!ProfileStackInterpreter methodsFor: 'experimental-bit-primitives' stamp: 'NickPapoulias 11/6/2014 20:57'!
primitiveSetExperimentalBit
	| boolean rcvr hdr wasImmutable |
	rcvr := self stackValue: 1.
	(self isIntegerObject: rcvr) ifTrue:
		[^self primitiveFailFor: PrimErrInappropriate].
	boolean := self booleanValueOf: self stackTop.
	self successful ifFalse:
		[^self primitiveFailFor: PrimErrBadArgument].
	self setExperimentalBitOf: rcvr to: boolean.
	self pop: 2! !

!ProfileStackInterpreter methodsFor: 'experimental-bit-primitives' stamp: 'NickPapoulias 11/6/2014 20:57'!
primitiveTurnOffExperimentalBitOfAllObjects
	| oop |
	oop := self firstAccessibleObject.
	[oop = nil] whileFalse: [
		(self isIntegerObject:  oop)
			ifFalse: [ 
				self setExperimentalBitOf: oop to: false
				].
		oop := self accessibleObjectAfter: oop.
	].
	! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:08'!
print: s
	"For testing in Smalltalk, this method should be overridden in a subclass."
	<api>
	<var: #s type: #'char *'>
	self cCode: 'fputs(s, stdout)'! !

!ProfileStackInterpreter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/12/2014 13:57'!
printProfilingResults
	<api>
	self cCode: 'printf("__VM_STATS__START__{ \
	#byteCodeCounter ->%llu. \
	#messageCounter -> %llu. \
	#primitiveCounter -> %llu. }.__VM_STATS__END__ \
	",bCounter,mCounter,pCounter);'.
	! !

!ProfileStackInterpreter methodsFor: 'experimental-bit-accesors' stamp: 'NickPapoulias 11/6/2014 20:56'!
setExperimentalBitOf: anOop to: boolean
	| hdr |
	self inline: true.
	"Dont check here if it is integer. Check in the sender of this."
	hdr := objectMemory baseHeader: anOop.
	boolean 
		ifTrue: [ objectMemory baseHeader: anOop put: (hdr bitOr: ExperimentalObjectBit). ]
		ifFalse: [ objectMemory baseHeader: anOop put: (hdr bitAnd: AllButExperimentalBit). ]! !

StackUnixConfig subclass: #ProfileUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling-Zen'!

ProfileUnixConfig subclass: #ExtendedProfileUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:23'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#include <stdint.h>
uint64_t bCounter;
uint64_t mCounter;
uint64_t pCounter;

uint64_t qPrimitiveCounter; /*sanity-check*/
uint64_t sPrimitiveCounter; /*sanity-check*/
uint64_t otherPrimitiveCounter; /*external, named e.t.c*/
uint64_t bArrayCounter[256];
uint64_t quickPrimitiveCounter[520];
uint64_t slowPrimitiveCounter[576];

/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!ExtendedProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:11'!
executableName
	^ 'ExtendedProfileStackVM'! !

!ExtendedProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:11'!
interpreterClass
	^ ExtendedProfileStackInterpreter! !

!ProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:07'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#include <stdint.h>
uint64_t bCounter;
uint64_t mCounter;
uint64_t pCounter;

/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!ProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:07'!
executableName
	^ 'ProfileStackVM'! !

!ProfileUnixConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/7/2014 16:07'!
interpreterClass
	^ ProfileStackInterpreter! !

StackUnixDebugConfig subclass: #ProfileUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling-Zen'!

!ProfileUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:25'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#include <stdint.h>
uint64_t bCounter;
uint64_t mCounter;
uint64_t pCounter;

/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!ProfileUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:07'!
executableName
	^ 'ProfileStackDebugVM'! !

!ProfileUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/5/2014 10:06'!
interpreterClass
	^ ProfileStackInterpreter! !

Object subclass: #Experiment
	instanceVariableNames: 'runs evalString numberOfRuns averageAndStDevRun targetImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!Experiment class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:07'!
newWith: aString times: numberOfRuns

	^ self new
		evalString: aString;
		times: numberOfRuns.! !

!Experiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/17/2014 20:43'!
averageAndStDevRun
	^ averageAndStDevRun! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 17:38'!
calculateAverageAndStDevRun

	|any numericIvs stDevDict|
	stDevDict := Dictionary new.
	averageAndStDevRun instVarNamed: 'stDevDict' put: stDevDict.
	averageAndStDevRun instVarNamed: 'executedSuccessfully' put: true.
	any := runs anyOne.
	numericIvs := self runClass allInstVarNames select: [ :iv | (any instVarNamed: iv asString) isKindOf: Number ].
	numericIvs do: [ :iv | |ivInRuns|
		ivInRuns := (runs collect: [:run | run instVarNamed: iv]). 
		averageAndStDevRun
			instVarNamed: iv 
			put:  ivInRuns average.
		stDevDict at: iv put: ivInRuns stdev. 
	].
	averageAndStDevRun sanityCheck.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 19:26'!
csvLine

	^ averageAndStDevRun csvLine! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 19:26'!
csvLineHeader

	^ averageAndStDevRun csvLineHeader! !

!Experiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:47'!
evalString
	^ evalString! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:23'!
evalString: aString

	evalString := aString! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:21'!
initialize

	super initialize.
	runs := OrderedCollection new.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 12:50'!
logRun: i

	(OSProcess thisOSProcess stdOut)
		nextPutAll: '--> Run: ' , i asString , ' of: ', numberOfRuns asString;
		flush.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 17:38'!
run

	(1 to: numberOfRuns) do:  [ :i |
		self logRun: i.
		runs add: ((self runClass newWith: evalString) targetImage: self targetImage) run sanityCheck.
	 ].
	averageAndStDevRun := self runClass new.
	self calculateAverageAndStDevRun.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:53'!
runClass

	self subclassResponsibility ! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 12:17'!
sanityCheck

	runs do:  [ :each | each sanityCheck ].
	averageAndStDevRun sanityCheck.! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:18'!
targetImage

	^ targetImage! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:19'!
targetImage: aString

	targetImage := aString! !

!Experiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 19:08'!
times: aNumber

	numberOfRuns := aNumber! !

Experiment subclass: #VanillaExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

VanillaExperiment subclass: #ProfileExperiment
	instanceVariableNames: 'slowDownInSeconds slowDownX'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ProfileExperiment subclass: #ExtendedProfileExperiment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:16'!
runClass

	^ ExtendedProfileExperimentRun ! !

!ProfileExperiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/27/2014 17:38'!
calculateAverageAndStDevRun
	averageAndStDevRun instVarNamed: 'testSuiteSuccess' put: true.
	super calculateAverageAndStDevRun! !

!ProfileExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:16'!
runClass

	^ ProfileExperimentRun! !

!ProfileExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 04:35'!
slowDownFrom: aVanillaExperiment

	self assert: (aVanillaExperiment class = VanillaExperiment).
	self assert: (aVanillaExperiment evalString = evalString).
	slowDownInSeconds := averageAndStDevRun realTime - aVanillaExperiment averageAndStDevRun realTime.
	slowDownX := averageAndStDevRun realTime / aVanillaExperiment averageAndStDevRun realTime.! !

!ProfileExperiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 12:13'!
slowDownInSeconds
	^ slowDownInSeconds! !

!ProfileExperiment methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 12:14'!
slowDownX
	^ slowDownX! !

!VanillaExperiment methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:15'!
runClass

	^ VanillaExperimentRun! !

Object subclass: #ExperimentScript
	instanceVariableNames: 'setUpVanilla setUpProfiling setUpExtendedProfiling vanillaFile profileFile extendedProfileFile vanillaCsv profilingCsv extendedCsv'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ExperimentScript subclass: #CoreAndAppsExperimentScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!CoreAndAppsExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 19:21'!
categories

	^ #coreAndAppsCategories
						! !

!CoreAndAppsExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 19:05'!
numberOfRuns

	^ 10
						! !

!CoreAndAppsExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 19:21'!
targetImage

	^ 'Pharo-20628-apps.image'! !

CoreAndAppsExperimentScript subclass: #CoreAndAppsSingleRunScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!CoreAndAppsSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 17:51'!
numberOfRuns
	^ 2! !

!CoreAndAppsSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:30'!
runExtendedProfiling
	! !

!CoreAndAppsSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:35'!
runProfiling
	
	setUpProfiling := ((ProfilingExperimentSetUp 
						newWith: self categories
						forExperimentClass: ProfileExperiment 
						withNumberOfRunsPerCategory: self numberOfRuns) targetImage: self targetImage) run.
	
	"setUpProfiling slowDownFrom: setUpVanilla."
	profileFile := setUpProfiling exportToFuel.
	profilingCsv := setUpProfiling exportToCsv.! !

!CoreAndAppsSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:29'!
runVanilla! !

CoreAndAppsExperimentScript subclass: #CoreAndAppsWeightedExampleScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!CoreAndAppsWeightedExampleScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:37'!
categories

	^ #greenWeightedCoreAndAppsExampleCategoriesDict
						! !

!CoreAndAppsWeightedExampleScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:36'!
numberOfRuns
	
	^ 2! !

!CoreAndAppsWeightedExampleScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:33'!
setUpClass

	^ WeightedProfilingExperimentSetUp! !

CoreAndAppsExperimentScript subclass: #CoreAndAppsWeightedExperimentScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!CoreAndAppsWeightedExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:37'!
categories

	^ #greenWeightedCoreAndAppsCategoriesDict
						! !

!CoreAndAppsWeightedExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:32'!
setUpClass

	^ WeightedProfilingExperimentSetUp! !

ExperimentScript subclass: #CoreSystemExperimentScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!CoreSystemExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 19:21'!
categories

	^ #coreCategories
						! !

!CoreSystemExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 13:22'!
numberOfRuns

	^ 10
						! !

!CoreSystemExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:34'!
targetImage

	^ 'Pharo-20628.image'! !

CoreSystemExperimentScript subclass: #CoreSystemSingleRunScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!CoreSystemSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 17:51'!
numberOfRuns

	^ 2! !

!CoreSystemSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:44'!
runExtendedProfiling
! !

!CoreSystemSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:46'!
runProfiling

	setUpProfiling := ((ProfilingExperimentSetUp 
						newWith: self categories
						forExperimentClass: ProfileExperiment 
						withNumberOfRunsPerCategory: self numberOfRuns) targetImage: self targetImage) run.
	
	"setUpProfiling slowDownFrom: setUpVanilla."
	profileFile := setUpProfiling exportToFuel.
	profilingCsv := setUpProfiling exportToCsv.! !

!CoreSystemSingleRunScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:45'!
runVanilla
! !

ExperimentScript subclass: #ExampleExperimentScript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExampleExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 11:45'!
categories

	^ #exampleCategories! !

!ExampleExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 13:30'!
numberOfRuns
	
	^ 2! !

!ExampleExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:34'!
targetImage

	^ 'Pharo-20628.image'! !

!ExperimentScript class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 12:32'!
importFromFuelFileName: aFileName

	^ FLMaterializer materializeFromFileNamed: aFileName! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 13:22'!
categories

	self subclassResponsibility ! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:36'!
deleteFiles

	(FileSystem workingDirectory / vanillaFile) delete.
	(FileSystem workingDirectory / profileFile) delete.
	(FileSystem workingDirectory / extendedProfileFile) delete.
	! !

!ExperimentScript methodsFor: 'accessing' stamp: 'NickPapoulias 6/29/2014 11:55'!
exportToFuel

	|filename|
	filename := self class name , '_' , DateAndTime now printString , '.script'.
	FLSerializer serialize: self toFileNamed: filename.
	^ filename
! !

!ExperimentScript methodsFor: 'accessing' stamp: 'NickPapoulias 6/19/2014 13:41'!
extendedProfileFile
	^ extendedProfileFile! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 13:22'!
numberOfRuns

	self subclassResponsibility ! !

!ExperimentScript methodsFor: 'accessing' stamp: 'NickPapoulias 6/19/2014 13:41'!
profileFile
	^ profileFile! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 14:24'!
run

	self runVanilla.
	self runProfiling.
	self runExtendedProfiling.
	self exportToFuel.! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:31'!
runExtendedProfiling

	
	setUpExtendedProfiling := ((self setUpClass
									newWith: self categories
									forExperimentClass: ExtendedProfileExperiment 
									withNumberOfRunsPerCategory: self numberOfRuns) targetImage: self targetImage) run.
									
	setUpExtendedProfiling slowDownFrom: setUpVanilla.
	extendedProfileFile := setUpExtendedProfiling exportToFuel.
	extendedCsv := setUpExtendedProfiling exportToCsv.! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:31'!
runProfiling
	
	setUpProfiling := ((self setUpClass
						newWith: self categories
						forExperimentClass: ProfileExperiment 
						withNumberOfRunsPerCategory: self numberOfRuns) targetImage: self targetImage) run.
	
	setUpProfiling slowDownFrom: setUpVanilla.
	profileFile := setUpProfiling exportToFuel.
	profilingCsv := setUpProfiling exportToCsv.

	
! !

!ExperimentScript methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:31'!
runVanilla

	
	setUpVanilla := ((self setUpClass
						newWith: self categories
						forExperimentClass: VanillaExperiment 
						withNumberOfRunsPerCategory: self numberOfRuns) targetImage: self targetImage) run.

	vanillaFile := setUpVanilla exportToFuel.
	vanillaCsv := setUpVanilla exportToCsv.! !

!ExperimentScript methodsFor: 'accessing' stamp: 'NickPapoulias 7/6/2014 16:30'!
setUpClass

	^ ProfilingExperimentSetUp ! !

!ExperimentScript methodsFor: 'accessing' stamp: 'NickPapoulias 6/27/2014 15:33'!
targetImage

	! !

!ExperimentScript methodsFor: 'accessing' stamp: 'NickPapoulias 6/19/2014 13:41'!
vanillaFile
	^ vanillaFile! !

Object subclass: #ProfilingExperimentSetUp
	instanceVariableNames: 'categories experimentClass numberOfRunsForEachCategory experiments selector slowDownInSeconds slowDownX targetImage failedExperimentsAndAssertions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 19:20'!
coreAndAppsCategories

	"generated by running calculateGreenTrainingCategories in target image -- see script in results folder this is headless -- here Pharo 2.0"
	
	^      #('Roassal-Event-Tests' 'XML-Tests-Parser' 'Pomodoro-Tests' 'Tests-Polymorph-Widgets' 'SUnit-Core-Extensions' 'CollectionsTests-Streams' 'Infinity-Tests' 'Glamour-Morphic-Renderer-Spotter' 'ToolsTest-Debugger' 'Hashtable-Test' 'Glamour-Tests-EyeSee' 'Goodies-Lisp-Test' 'Roassal-Interaction-Tests' 'Zodiac-Tests' 'ToolsTest-Base' 'Neo-CSV-Tests' 'CollectionsTests-Sequenceable' 'ToolsTest-PointerFinder' 'UpdateStreamer-Tests' 'Magritte-Tests-Model-Core' 'Roassal-AttachPoint-Test' 'RoassalMorphic-Test' 'Ring-Tests-Kernel' 'PetitTests-Core' 'Tests-Compression' 'CollectionsTests-Unordered' 'SMark-Tests' 'Refactoring-Tests-Environment' 'CommandShell-Tests' 'Roassal-PlatformIndependent' 'FFI-Tests' 'GT-Metaceller-Tests' 'Roassal-Transformation' 'Scripting-Tests' 'GlorpTests-Models' 'Magritte-Tests-Model-Description' 'MorphicTests-Widgets' 'Barcode-Tests-Core-QR' 'Artefact-Tests-Elements' 'FreeTypeTests-cache' 'KernelTests-Exception' 'Glamour-Tests-Rubric' 'NPB-Tests' 'NECompletion-Tests' 'Manifest-Tests' 'Tests-Multilingual' 'Tests-CodeImport' 'Zinc-Zodiac' 'Chalten-TimeLineFilterModel-Tests' 'Artefact-Tests-Base' 'Roassal-Builder-Tests' 'Roassal-Hooks-Tests' 'Roassal-Normalizers-Tests' 'Keymapping-Tests' 'Tests-System' 'Glamour-Tests-Core' 'MorphicTests-Layouts' 'Ring-Tests-Containers' 'TextTests' 'CompressionTests-Archive' 'EyeSee-Tests-Core' 'MorphicTests-Event' 'CollectionExtensions' 'RoassalExtras-TreeMap-Tests' 'FuelTests-Collections' 'Aconcagua-GraphModel-Tests' 'HelpSystem-Tests-Builders' 'Tests-Bugs' 'Graphics-Tests-Primitives' 'Tests-Files' 'Refactoring-Tests-Changes' 'ToolsTest-Inspector' 'AST-Tests-Semantic' 'KernelTests-Methods' 'Roassal-Layout-Tests' 'NetworkTests-RFC822' 'Magritte-Tests-Model-Utility' 'Aconcagua-ArithmeticModel-Tests' 'LED-Test' 'Refactoring-Tests-Core' 'Graph-ET-Util-Tests' 'NECompletion-View-Tests' 'Tests-Traits-MOP' 'SUnit-UITesting' 'Roassal-Widgets-Tests' 'Magritte-Tests-Model-Memento' 'Units-Tests' 'Magritte-Tests-Model-Accessor' 'OpenDBXDriverTests-Encoding' 'GlorpTests-DatabaseTypes' 'Ring-Tests-Monticello' 'Spec-Tests' 'GlorpOpenDBXDriverTests' 'Roassal-Core-Tests' 'OpenDBXDriverTests-Extras' 'PetitTests-Tests' 'XML-Tests-Parser-DOM' 'RPackage-Tests' 'Barcode-Tests-Core-EAN' 'OSProcess-Tests' 'Iliad-Tests-Formula' 'SUnit-Tests-Core' 'Chalten-JulianTimeModel-Tests' 'Phexample-Core' 'Tests-ScriptLoader' 'CL-Benchmarks-Game-Tests' 'Log4s-Tests' 'CollectionsTests-Strings' 'Artefact-Tests-Generator' 'GT-Tests-Inspector' 'MorphicTests-Kernel' 'Phexample-Test' 'OpenDBXDriverTests' 'Tests-PackageInfo' 'NetworkTests-URI' 'FixedDecimal Tests' 'CollectionsTests-Support' 'BalloonTests-Collections' 'Math-ComplexTests' 'Artefact-Tests-DataTypes' 'KernelTests-Chronology' 'CollectionsTests-Atomic' 'DynamicBindings' 'AndreasProfiler' 'InstanceEncoder' 'Graph-ET-Core-Tests' 'Chalten-TimeZoneModel-Tests' 'NetworkTests-UUID' 'HelpSystem-Tests-Core-Model' 'KernelTests-Processes' 'SUnit-Core-Kernel' 'PetitGui-Tests' 'Iliad-Tests-RequestHandlers' 'Iliad-Tests-RSS' 'Roassal-Visitor-Tests' 'HelpSystem-Tests-Core-UI' 'Citezen-Reborn' 'SUnit-Core-Utilities' 'Iliad-Tests-Utilities' 'Iliad-Tests-Dispatching' 'KernelTests-Numbers' 'Roassal-Layout' 'ShoutTests-Styling' 'KernelTests-Objects' 'FileSystem-Tests-Memory' 'Roassal-Actions-Tests' 'Tests-Exceptions' 'Citezen-Tests' 'Magritte-Tests-Model-Models' 'Graphics-Tests-Files' 'FuelTests-Streams' 'GlorpTests-Extras' 'Zinc-Character-Encoding-Tests' 'Balloon-Fills-Tests' 'Autotest-Tests-Core' 'Fame-Tests-Core' 'Multilingual-Tests-TextConversion' 'Chalten-GregorianTimeModel-Tests' 'OnlineHelp-Tests' 'Iliad-Tests-lib-HTTP' 'Artefact-Tests-Layouts' 'ShoutTests-Parsing' 'Tests-ObjectsAsMethods' 'Zinc-Resource-Meta-Tests' 'Chalten-HebrewTimeModel-Tests' 'Zinc-Resource-Meta-FileSystem' 'LDAP-Tests' 'Tests-Object Events' 'CompilerTests' 'FuelTests' 'GlorpTests' 'Tests-System-CommandLine' 'Tests-Release' 'Tests-TextEditors' 'Tests-Traits' 'NetworkTests-Mail' 'RPackage-SystemIntegration' 'BabyMock-Core' 'PetitAnalyzer-Tests' 'NetworkTests-Kernel' 'AST-Tests-Core' 'ToolsTest-Finder' 'Tests-SystemChangeNotification' 'CollectionsTests-SplitJoin' 'Grease-Tests-Slime' 'FileSystem-Tests-Core' 'Grease-Tests-Pharo20-Core' 'Announcements-Tests-Core' 'Tests-Digital Signatures' 'Refactoring-Tests-Critics' 'HelpSystem-Tests-Core-Utilities' 'INIFile-Tests' 'Iliad-Tests-Sessions' 'CollectionsTests-Weak' 'CollectionsTests-Abstract' 'Zinc-Tests' 'KernelTests-Pragmas' 'KernelTests-Classes' 'Tests-SystemTests-Support' 'RoassalExtras-BSpline-Tests' 'Chalten-ChristianTimeModel-Tests' 'NetworkTests-Protocols' 'Chalten-IslamicTimeModel-Tests' 'Gofer-Tests' 'ConfigurationCommandLineHandler-Tests' 'Glamour-Tests-Morphic' 'Glamour-Tests-Roassal' 'MorphicTests-Basic' 'Aconcagua-MeasureModel-Tests' 'Grease-Tests-Core' 'CollectionsTests-Arrayed' 'Barcode-Tests-Core' 'Iliad-Tests-Buildables' 'MorphicTests-Text Support' 'Roassal-Exporter-Tests' 'Iliad-Tests-lib-JSON' 'Swazoo-Tests' 'XML-Writer-Tests' 'MorphicTests-WindowNotification' 'Nautilus-Tests' 'Tests-Finalization' 'Tests-VM' 'Tests-Monticello' 'NetworkTests-Url' 'Tests-SystemHistory' 'Alt-Browser-Tests' 'ToolsTest-MessageTally' 'Autotest-Tests-GUI' 'Regex-Tests-Core' 'ProfStef-Tests' 'CollectionsTests-Stack' 'Chalten-TimeModel-Tests' 'Spec-Tools-Senders-Tests' 'FileSystem-Tests-Disk' 'Aida-Tests' 'GlorpTests-Database' 'Pastell-Tests' 'Iliad-Tests-Elements' 'Magritte-Tests-Pharo-Model')! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 19:19'!
coreCategories

	"generated by running calculateGreenTrainingCategories in target image -- see script in results folder this is headless -- here Pharo 2.0"
	
	^     #('FuelTests' 'KernelTests-Methods' 'NetworkTests-Kernel' 'SUnit-Core-Extensions' 'Refactoring-Tests-Changes' 'KernelTests-Objects' 'HelpSystem-Tests-Core-Model' 'Tests-System' 'Tests-Traits' 'KernelTests-Chronology' 'Nautilus-Tests' 'ConfigurationCommandLineHandler-Tests' 'Tests-ScriptLoader' 'ShoutTests-Styling' 'NetworkTests-RFC822' 'RPackage-Tests' 'Multilingual-Tests-TextConversion' 'CompilerTests' 'Zinc-Zodiac' 'RPackage-SystemIntegration' 'CollectionsTests-SplitJoin' 'KernelTests-Pragmas' 'MorphicTests-Layouts' 'Ring-Tests-Containers' 'Tests-SystemTests-Support' 'Ring-Tests-Kernel' 'Refactoring-Tests-Core' 'Zinc-Tests' 'CollectionsTests-Support' 'NECompletion-View-Tests' 'MorphicTests-Basic' 'CollectionsTests-Atomic' 'UpdateStreamer-Tests' 'Tests-ObjectsAsMethods' 'Tests-SystemChangeNotification' 'ToolsTest-Inspector' 'Tests-Multilingual' 'AST-Tests-Semantic' 'Regex-Tests-Core' 'SUnit-Tests-Core' 'Keymapping-Tests' 'FileSystem-Tests-Memory' 'CompressionTests-Archive' 'Gofer-Tests' 'CollectionsTests-Strings' 'Tests-Release' 'MorphicTests-Text Support' 'AST-Tests-Core' 'SUnit-Core-Kernel' 'NetworkTests-Url' 'NetworkTests-UUID' 'Tests-PackageInfo' 'FreeTypeTests-cache' 'CollectionsTests-Sequenceable' 'SUnit-UITesting' 'SUnit-Core-Utilities' 'KernelTests-Exception' 'Tests-TextEditors' 'KernelTests-Classes' 'ShoutTests-Parsing' 'MorphicTests-WindowNotification' 'Tests-VM' 'CollectionsTests-Stack' 'Tests-Object Events' 'Tests-Finalization' 'Refactoring-Tests-Critics' 'Balloon-Fills-Tests' 'Refactoring-Tests-Environment' 'HelpSystem-Tests-Core-UI' 'Graphics-Tests-Files' 'Tests-SystemHistory' 'TextTests' 'FileSystem-Tests-Core' 'Tests-Polymorph-Widgets' 'Graphics-Tests-Primitives' 'Tests-Monticello' 'ToolsTest-PointerFinder' 'CollectionsTests-Unordered' 'CollectionsTests-Streams' 'Tests-Digital Signatures' 'Zodiac-Tests' 'NECompletion-Tests' 'Tests-Exceptions' 'MorphicTests-Event' 'ProfStef-Tests' 'CollectionsTests-Weak' 'NetworkTests-URI' 'Zinc-Resource-Meta-Tests' 'BalloonTests-Collections' 'Ring-Tests-Monticello' 'ToolsTest-MessageTally' 'CollectionsTests-Arrayed' 'MorphicTests-Kernel' 'Zinc-Character-Encoding-Tests' 'KernelTests-Numbers' 'Tests-Compression' 'Tests-System-CommandLine' 'NetworkTests-Mail' 'Tests-Traits-MOP' 'Spec-Tools-Senders-Tests' 'FileSystem-Tests-Disk' 'AndreasProfiler' 'HelpSystem-Tests-Core-Utilities' 'FuelTests-Collections' 'Tests-Files' 'Announcements-Tests-Core' 'KernelTests-Processes' 'ToolsTest-Finder' 'ToolsTest-Base' 'Manifest-Tests' 'Spec-Tests' 'MorphicTests-Widgets' 'Tests-CodeImport' 'ToolsTest-Debugger' 'NetworkTests-Protocols' 'HelpSystem-Tests-Builders' 'Tests-Bugs' 'FuelTests-Streams' 'CollectionsTests-Abstract' 'Zinc-Resource-Meta-FileSystem')! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 12:38'!
exampleCategories

	
	^     #('FuelTests' 'KernelTests-Methods' 'NetworkTests-Kernel' 'SUnit-Core-Extensions')! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/24/2014 18:29'!
greenTrainingCategories

	"generated by running calculateGreenTrainingCategories in target image -- see script in results folder this is headless -- here Pharo 2.0"
	
	^    #(#'AST-Tests-Core' #'AST-Tests-Semantic' #AndreasProfiler #'Announcements-Tests-Core' #'Balloon-Fills-Tests' #'BalloonTests-Collections' #'CollectionsTests-Abstract' #'CollectionsTests-Arrayed' #'CollectionsTests-Atomic' #'CollectionsTests-Sequenceable' #'CollectionsTests-SplitJoin' #'CollectionsTests-Stack' #'CollectionsTests-Streams' #'CollectionsTests-Strings' #'CollectionsTests-Support' #'CollectionsTests-Unordered' #'CollectionsTests-Weak' #'CompressionTests-Archive' #'ConfigurationCommandLineHandler-Tests' #'FileSystem-Tests-Core' #'FileSystem-Tests-Memory' #'FreeTypeTests-cache' #FuelTests #'FuelTests-Collections' #'FuelTests-Streams' #'Graphics-Tests-Files' #'Graphics-Tests-Primitives' #'HelpSystem-Tests-Builders' #'HelpSystem-Tests-Core-Model' #'KernelTests-Chronology' #'KernelTests-Exception' #'KernelTests-Numbers' #'KernelTests-Objects' #'KernelTests-Pragmas' #'KernelTests-Processes' #'Keymapping-Tests' #'MorphicTests-Basic' #'MorphicTests-Event' #'MorphicTests-Kernel' #'MorphicTests-Layouts' #'MorphicTests-Text Support' #'MorphicTests-Widgets' #'MorphicTests-WindowNotification' #'Multilingual-Tests-TextConversion' #'NECompletion-Tests' #'NECompletion-View-Tests' #'Nautilus-Tests' #'NetworkTests-Kernel' #'NetworkTests-Mail' #'NetworkTests-Protocols' #'NetworkTests-RFC822' #'NetworkTests-URI' #'NetworkTests-UUID' #'NetworkTests-Url' #'Refactoring-Tests-Core' #'Refactoring-Tests-Critics' #'Refactoring-Tests-Environment' #'Regex-Tests-Core' #'Ring-Tests-Containers' #'Ring-Tests-Monticello' #'SUnit-Core-Extensions' #'SUnit-Core-Kernel' #'SUnit-Core-Utilities' #'SUnit-Tests-Core' #'SUnit-UITesting' #'ShoutTests-Parsing' #'ShoutTests-Styling' #'Spec-Tests' #'Spec-Tools-Senders-Tests' #'Tests-Bugs' #'Tests-Compression' #'Tests-Digital Signatures' #'Tests-Exceptions' #'Tests-Files' #'Tests-Finalization' #'Tests-Multilingual' #'Tests-Object Events' #'Tests-ObjectsAsMethods' #'Tests-PackageInfo' #'Tests-Polymorph-Widgets' #'Tests-Release' #'Tests-ScriptLoader' #'Tests-System-CommandLine' #'Tests-SystemChangeNotification' #'Tests-SystemHistory' #'Tests-SystemTests-Support' #'Tests-TextEditors' #'Tests-Traits-MOP' #'Tests-VM' #TextTests #'ToolsTest-Base' #'ToolsTest-Debugger' #'ToolsTest-Finder' #'ToolsTest-Inspector' #'ToolsTest-MessageTally' #'ToolsTest-PointerFinder' #'UpdateStreamer-Tests' #'Zinc-Character-Encoding-Tests' #'Zinc-Resource-Meta-FileSystem' #'Zinc-Resource-Meta-Tests' #'Zinc-Zodiac')! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 16:05'!
importFromFuelFileName: aFileName

	^ FLMaterializer materializeFromFileNamed: aFileName.! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 21:02'!
newWith: categoriesSelector forExperimentClass: anExperimentClass withNumberOfRunsPerCategory: numberOfRuns

	^ self new
		initializeWith: categoriesSelector
		forExperimentClass: anExperimentClass
		withNumberOfRunsPerCategory: numberOfRuns.! !

!ProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 15:50'!
testCategories

	
	^  #(#'AST-Tests-Core' #'AST-Tests-Semantic')! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 12:57'!
calculateWeightedGreenCategories
	
	"store since each call distributes experiment < threshold differently"
	
	
	|threshold maxIterations weightedGreenCategories generator |
	
	generator := Random new.
	maxIterations := 60.
	threshold := 3.0.
	weightedGreenCategories := OrderedCollection new.
	
	experiments keysAndValuesDo: [ :key :experiment | 
		experiment averageAndStDevRun realTime < threshold 
			ifTrue: [ weightedGreenCategories add: key -> (generator nextInt: maxIterations) ]
			ifFalse: [ weightedGreenCategories add: key -> 1 ]
	].

	^ weightedGreenCategories asArray! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:30'!
evalStringForCategory: aCategory
	
	^ 'ProfilingTargetScript run: ' , aCategory printString.		! !

!ProfilingExperimentSetUp methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:53'!
experimentClass
	^ experimentClass! !

!ProfilingExperimentSetUp methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:52'!
experiments
	^ experiments! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 11:54'!
exportToCsv

	| filename working stream contents |
	filename := 'ProfilingExperimentSetup' , '_' , experimentClass printString , '_' , DateAndTime now printString , '.csv'.
	working := FileSystem disk workingDirectory.
	stream := (working / filename) writeStream.
	contents := 'category,' , experiments anyOne csvLineHeader , Character cr asString.
	experiments keysAndValuesDo: [ :key :value | 
		contents := contents , key asString , ',' , value csvLine , Character cr asString
	].
	stream nextPutAll: contents.
	stream close.
	^ filename.! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/18/2014 15:56'!
exportToFuel

	|filename|
	filename := 'ProfilingExperimentSetup' , '_' , experimentClass printString , '_' , DateAndTime now printString , '.experiment'.
	FLSerializer serialize: self toFileNamed: filename.
	^ filename
! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:08'!
initializeCategoriesWith: categoriesSelector

	categories := self class perform: categoriesSelector. 

! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:09'!
initializeWith: categoriesSelector forExperimentClass: anExperimentClass withNumberOfRunsPerCategory: numberOfRuns

	selector := categoriesSelector.
	self initializeCategoriesWith: categoriesSelector.
	experimentClass := anExperimentClass.  
	numberOfRunsForEachCategory := numberOfRuns.
	experiments := Dictionary new.! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/21/2014 11:56'!
logAssertion: experimentIndex

	(OSProcess thisOSProcess stdOut)
		nextPutAll: 
			'ASSERTION FAILURE --' , 
			self experimentClass printString , '--' , 
			'EXPERIMENT-NO: ' , experimentIndex printString;
		flush.
		 
		! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/19/2014 04:56'!
logCategory: category

	(OSProcess thisOSProcess stdOut)
		nextPutAll: 
			self class printString , '--' , 
			self experimentClass printString , '--' , 
			category , ' ' , 
			'(Category: ' , (categories indexOf: category) asString , ' of: ' , categories size asString , ')';
		flush.
		 
		! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/5/2014 19:56'!
run

	|experiment |
	failedExperimentsAndAssertions := Dictionary new.
	
	categories do: [ :category | 
		self logCategory: category.
		[
			experiment := ((experimentClass 
								newWith: (self evalStringForCategory: category) 
								times: numberOfRunsForEachCategory) 
									targetImage: self targetImage). 
			experiment run.
			experiments at: category put: experiment
		] on: Error do: [:ex | 
			failedExperimentsAndAssertions at: experiment put: ex.	
		].
	].  
		 
	failedExperimentsAndAssertions
		! !

!ProfilingExperimentSetUp methodsFor: 'accessing' stamp: 'NickPapoulias 6/18/2014 11:55'!
selector
	^ selector! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 11:21'!
slowDownFrom: anExperimentalSetUp

	|vanillaExperiments|
	
	vanillaExperiments := anExperimentalSetUp experiments.
	
	self assert: (anExperimentalSetUp experimentClass = VanillaExperiment).
	self assert: (anExperimentalSetUp selector) = selector.
	"self assert: (vanillaExperiments size = experiments size)."  "this may not hold - if different categories have failed"
	
	slowDownInSeconds := OrderedCollection new.
	slowDownX := OrderedCollection new.
	experiments keysAndValuesDo: [ :key :value | 
		value slowDownFrom: (vanillaExperiments at: key). 
		slowDownInSeconds add: value slowDownInSeconds. 
		slowDownX add: value slowDownX ].
		
	slowDownInSeconds := (slowDownInSeconds average -> slowDownInSeconds stdev).
	slowDownX := (slowDownX average -> slowDownX stdev).! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:22'!
targetImage

	^ targetImage! !

!ProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:22'!
targetImage: aString

	targetImage := aString
		! !

ProfilingExperimentSetUp subclass: #WeightedProfilingExperimentSetUp
	instanceVariableNames: 'categoriesDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!WeightedProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:01'!
greenWeightedCoreAndAppsCategoriesDict

	"script := ExperimentScript importFromFuelFileName: CoreAndAppsSingleRunScript_2014-07-06T01:02:09.200715+02:00.script.
	(script instVarNamed: #setUpProfiling) calculateWeightedGreenCategories	
	"
	
	^   {'Magritte-Tests-Pharo-Model'->25. 'Nautilus-Tests'->56. 'TextTests'->23. 'Roassal-Layout'->18. 'InstanceEncoder'->1. 'NetworkTests-Protocols'->54. 'NetworkTests-Mail'->53. 'ToolsTest-Debugger'->12. 'Tests-Object Events'->34. 'Balloon-Fills-Tests'->55. 'NECompletion-View-Tests'->46. 'Zinc-Resource-Meta-Tests'->44. 'Refactoring-Tests-Critics'->1. 'Tests-ScriptLoader'->11. 'Tests-Traits-MOP'->37. 'Tests-Multilingual'->9. 'Spec-Tools-Senders-Tests'->44. 'Phexample-Core'->34. 'Ring-Tests-Containers'->42. 'SUnit-Core-Extensions'->43. 'ToolsTest-Inspector'->1. 'ConfigurationCommandLineHandler-Tests'->15. 'MorphicTests-Text Support'->32. 'INIFile-Tests'->40. 'SUnit-Tests-Core'->1. 'CollectionsTests-Strings'->1. 'RoassalExtras-TreeMap-Tests'->8. 'AST-Tests-Core'->1. 'CollectionsTests-Sequenceable'->1. 'CollectionsTests-SplitJoin'->9. 'Iliad-Tests-RSS'->50. 'Tests-Polymorph-Widgets'->1. 'MorphicTests-Event'->6. 'Tests-VM'->60. 'Regex-Tests-Core'->6. 'Iliad-Tests-Utilities'->1. 'Pomodoro-Tests'->37. 'ToolsTest-Base'->27. 'Iliad-Tests-Formula'->48. 'Iliad-Tests-Buildables'->9. 'Artefact-Tests-DataTypes'->41. 'Iliad-Tests-Sessions'->2. 'Roassal-PlatformIndependent'->7. 'Roassal-Actions-Tests'->56. 'ShoutTests-Parsing'->1. 'CollectionsTests-Streams'->56. 'CollectionsTests-Atomic'->4. 'NetworkTests-Url'->48. 'Tests-Exceptions'->22. 'CollectionsTests-Weak'->1. 'AndreasProfiler'->24. 'XML-Tests-Parser-DOM'->26. 'Glamour-Morphic-Renderer-Spotter'->48. 'SUnit-UITesting'->30. 'Tests-Digital Signatures'->59. 'MorphicTests-Widgets'->1. 'NetworkTests-UUID'->1. 'ToolsTest-MessageTally'->29. 'NetworkTests-URI'->2. 'Roassal-Hooks-Tests'->36. 'FuelTests'->1. 'Zinc-Zodiac'->35. 'UpdateStreamer-Tests'->47. 'Tests-SystemHistory'->50. 'Tests-PackageInfo'->1. 'NECompletion-Tests'->1. 'DynamicBindings'->57. 'Keymapping-Tests'->28. 'Aconcagua-ArithmeticModel-Tests'->14. 'Graph-ET-Util-Tests'->2. 'Chalten-ChristianTimeModel-Tests'->42. 'NetworkTests-Kernel'->1. 'EyeSee-Tests-Core'->1. 'Autotest-Tests-GUI'->18. 'CollectionsTests-Support'->21. 'MorphicTests-WindowNotification'->22. 'MorphicTests-Kernel'->27. 'Tests-Compression'->18. 'LED-Test'->45. 'RoassalExtras-BSpline-Tests'->45. 'Citezen-Reborn'->19. 'Multilingual-Tests-TextConversion'->15. 'KernelTests-Objects'->48. 'ToolsTest-Finder'->14. 'FreeTypeTests-cache'->13. 'Glamour-Tests-Core'->35. 'Iliad-Tests-RequestHandlers'->11. 'Roassal-Builder-Tests'->1. 'SUnit-Core-Kernel'->41. 'Roassal-Normalizers-Tests'->57. 'XML-Tests-Parser'->1. 'XML-Writer-Tests'->6. 'BabyMock-Core'->23. 'Glamour-Tests-Roassal'->14. 'Iliad-Tests-lib-HTTP'->9. 'Graphics-Tests-Files'->1. 'BalloonTests-Collections'->38. 'Spec-Tests'->24. 'Roassal-Widgets-Tests'->57. 'Iliad-Tests-Elements'->30. 'Aida-Tests'->1. 'Zinc-Character-Encoding-Tests'->34. 'ShoutTests-Styling'->21. 'CollectionExtensions'->28. 'Roassal-Event-Tests'->6. 'Glamour-Tests-EyeSee'->25. 'Graphics-Tests-Primitives'->32. 'KernelTests-Numbers'->1. 'FixedDecimal Tests'->26. 'HelpSystem-Tests-Core-Model'->17. 'Tests-SystemTests-Support'->35. 'Aconcagua-GraphModel-Tests'->10. 'Math-ComplexTests'->29. 'MorphicTests-Basic'->32. 'Iliad-Tests-lib-JSON'->41. 'ToolsTest-PointerFinder'->1. 'Roassal-Exporter-Tests'->46. 'Ring-Tests-Monticello'->16. 'Neo-CSV-Tests'->59. 'MorphicTests-Layouts'->40. 'Roassal-Visitor-Tests'->32. 'Fame-Tests-Core'->1. 'PetitTests-Tests'->1. 'Barcode-Tests-Core-QR'->51. 'Graph-ET-Core-Tests'->54. 'Zinc-Resource-Meta-FileSystem'->36. 'PetitTests-Core'->51. 'Announcements-Tests-Core'->16. 'Tests-System-CommandLine'->27. 'Infinity-Tests'->53. 'KernelTests-Processes'->40. 'PetitAnalyzer-Tests'->48. 'KernelTests-Pragmas'->22. 'Tests-SystemChangeNotification'->17. 'CollectionsTests-Stack'->26. 'Refactoring-Tests-Environment'->1. 'FuelTests-Streams'->13. 'Tests-Finalization'->10. 'FuelTests-Collections'->52. 'Barcode-Tests-Core-EAN'->50. 'KernelTests-Exception'->7. 'Hashtable-Test'->1. 'Tests-TextEditors'->43. 'PetitGui-Tests'->21. 'AST-Tests-Semantic'->12. 'Tests-ObjectsAsMethods'->45. 'CompressionTests-Archive'->46. 'Roassal-AttachPoint-Test'->34. 'CollectionsTests-Arrayed'->1. 'Roassal-Transformation'->59. 'CollectionsTests-Unordered'->1. 'OpenDBXDriverTests-Encoding'->37. 'Roassal-Layout-Tests'->1. 'Barcode-Tests-Core'->54. 'Magritte-Tests-Model-Utility'->49. 'NetworkTests-RFC822'->25. 'Iliad-Tests-Dispatching'->55. 'GlorpOpenDBXDriverTests'->48} asDictionary! !

!WeightedProfilingExperimentSetUp class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:34'!
greenWeightedCoreAndAppsExampleCategoriesDict

	"script := ExperimentScript importFromFuelFileName: CoreAndAppsSingleRunScript_2014-07-06T01:02:09.200715+02:00.script.
	(script instVarNamed: #setUpProfiling) calculateWeightedGreenCategories	
	"
	
	^   {'Magritte-Tests-Pharo-Model'->25. 'Nautilus-Tests'->56.} asDictionary! !

!WeightedProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:12'!
evalStringForCategory: aCategory
	
	^ 'ProfilingTargetScript run: ' , aCategory printString , ' times: ' , (categoriesDict at: aCategory) printString.		! !

!WeightedProfilingExperimentSetUp methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/6/2014 16:10'!
initializeCategoriesWith: categoriesSelector

	categoriesDict := (self class perform: categoriesSelector).
	categories := categoriesDict keys.
	 
! !

Object subclass: #Run
	instanceVariableNames: 'evalString rawOutput rawTimeOutput executedSuccessfully stDevDict targetImage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!Run class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:20'!
newWith: aString

	^ self new
		evalString: aString! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 13:14'!
clearStats

	(FileSystem workingDirectory / 'output') exists ifTrue: [ (FileSystem workingDirectory / 'output') delete ].
	(FileSystem workingDirectory / 'timeOutput') exists ifTrue: [ (FileSystem workingDirectory / 'timeOutput') delete ].
	! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 18:25'!
csvExportVars! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 19:53'!
csvLine

	| line |
	line := self csvExportVars inject: '' into: [ :all :var | 
		|decimalAvg decimalStdDev|
		decimalAvg := ((self instVarNamed: var) isKindOf: Fraction) ifTrue: [ (self instVarNamed: var) asFloat asString ] ifFalse: [ (self instVarNamed: var) asString ].
		decimalStdDev := ((stDevDict at: var) isKindOf: Fraction) ifTrue: [ (stDevDict at: var) asFloat asString ] ifFalse: [ (stDevDict at: var) asString ].
		all , 
		decimalAvg , ',' ,
		decimalStdDev , ','
	].
	^ line truncateTo: line size -1.
		! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 19:18'!
csvLineHeader

	| line |
	line :=  self csvExportVars inject: '' into: [ :all :var | 
		all , 
		var asString , ',' ,
		var asString , 'StDev,'
	].
	^ line truncateTo: line size -1
		! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 13:19'!
evalString: aString

	evalString := aString! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:39'!
parseOutput
! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 20:21'!
path

	^ '/home/art/Desktop/june/mStackVM/sources/results/'! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 15:02'!
postProcessing! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 15:03'!
run

	"check also /usr/bin/time -- has more stats -- its the default if you dont invoke bash"

	| rStream |
	self clearStats.
	OSProcess waitForCommand: 'time -p -o timeOutput ' , self path , self vm , ' -vm-display-X11 -headless ' , self path, self targetImage , ' eval "' , evalString , '" > output'.
	rStream := (FileSystem workingDirectory / 'output') readStream.
	rawOutput  := rStream contents.
	rStream close.
	rStream := (FileSystem workingDirectory / 'timeOutput') readStream.
	rawTimeOutput  := rStream contents.
	rStream close.
	(rawTimeOutput findString: 'non-zero') ~= 0 ifTrue: [ executedSuccessfully := false ] ifFalse: [ executedSuccessfully := true ].
	self clearStats.
	executedSuccessfully ifTrue: [self parseOutput. self postProcessing]. "sanity checks better left afterwards"! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 15:05'!
sanityCheck

	"collect assertion with an on:do: from client code -- use also in tests"
	
	self assert: executedSuccessfully 
! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:12'!
targetImage

	^ targetImage! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:12'!
targetImage: aString

	targetImage := aString! !

!Run methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 11:40'!
vm

	^ 'StackVM'! !

Run subclass: #VanillaExperimentRun
	instanceVariableNames: 'realTime userTime systemTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

VanillaExperimentRun subclass: #ProfileExperimentRun
	instanceVariableNames: 'byteCodeCounter messageCounter primitiveCounter statsDict byteCodesPerSecond primitivesPerSecond messagesPerSecond testSuiteSuccess testResultsSummary successDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

ProfileExperimentRun subclass: #ExtendedProfileExperimentRun
	instanceVariableNames: 'byteCodes quickPrimitives slowPrimitives qPrimitiveCounter otherPrimitiveCounter byteCodeSum quickPrimitiveSum slowPrimitiveSum stackByteCodeSum returnByteCodeSum sendByteCodeSum jumpByteCodeSum stackRatio returnRatio sendRatio jumpRatio primitiveRatioToMessages primitiveRatioToByteCode quickRatioToPrimitives slowRatioToPrimitives otherRatioToPrimitives sPrimitiveCounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UnixMetaStack-Profiling'!

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 18:57'!
csvExportVars

	^ super csvExportVars 
		addAll: {  
		#quickPrimitiveSum .
		#slowPrimitiveSum . 
		#otherPrimitiveCounter . 
		#primitiveRatioToByteCode . 
		#primitiveRatioToMessages . 
		#stackByteCodeSum . 
		#returnByteCodeSum . 
		#sendByteCodeSum . 
		#jumpByteCodeSum . 
		#quickRatioToPrimitives . 
		#slowRatioToPrimitives . 
		#otherRatioToPrimitives . 
		#stackRatio .
		#returnRatio . 
		#sendRatio . 
		#jumpRatio  
		} asOrderedCollection;
		yourself 
		! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:17'!
parseOutput

	super parseOutput. "gathers time output and statsDict"
	byteCodes := statsDict at: #byteCode.
	quickPrimitives := statsDict at: #quickPrimitive.
	slowPrimitives := statsDict at: #slowPrimitive.
	qPrimitiveCounter := statsDict at: #qPrimitiveCounter.
	sPrimitiveCounter := statsDict at: #sPrimitiveCounter.
	otherPrimitiveCounter := statsDict at: #otherPrimitiveCounter.! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/17/2014 20:04'!
postProcessing

	super postProcessing.

	byteCodeSum := byteCodes sum: [:each | each].
	quickPrimitiveSum := quickPrimitives sum: [:each | each].
	slowPrimitiveSum := slowPrimitives sum: [:each | each].
	stackByteCodeSum := 
		((byteCodes collect: [:each | each] from: 1 to: 120) ,  
		(byteCodes collect: [:each | each] from: 129 to: 131) , 
		(byteCodes collect: [:each | each] from: 136 to: 144)) sum: [ :each | each ].
	returnByteCodeSum := ((byteCodes collect: [:each | each] from: 121 to: 128)) sum: [ :each | each ].
	sendByteCodeSum := 
		((byteCodes collect: [:each | each] from: 132 to: 135) ,  
			(byteCodes collect: [:each | each] from: 177 to: 256)) sum: [ :each | each ].
	jumpByteCodeSum := ((byteCodes collect: [:each | each] from: 145 to: 176)) sum: [ :each | each ].
	returnRatio := returnByteCodeSum / byteCodeSum.
	sendRatio := sendByteCodeSum / byteCodeSum.
	jumpRatio := jumpByteCodeSum / byteCodeSum.
	stackRatio := stackByteCodeSum / byteCodeSum.
	primitiveRatioToMessages := primitiveCounter / messageCounter.
	primitiveRatioToByteCode := primitiveCounter / byteCodeCounter.
	quickRatioToPrimitives := quickPrimitiveSum / primitiveCounter.
	slowRatioToPrimitives := slowPrimitiveSum / primitiveCounter.
	otherRatioToPrimitives := otherPrimitiveCounter / primitiveCounter.! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/16/2014 18:59'!
sanityCheck

	super sanityCheck.
	self assert: (byteCodeCounter = byteCodeSum).
	self assert: (qPrimitiveCounter = quickPrimitiveSum).
	self assert: (sPrimitiveCounter = slowPrimitiveSum).
	self assert: (primitiveCounter = (quickPrimitiveSum + slowPrimitiveSum + otherPrimitiveCounter)).
	self assert: (byteCodeCounter = (stackByteCodeSum + returnByteCodeSum + sendByteCodeSum + jumpByteCodeSum)).
	self assert: (messageCounter <= sendByteCodeSum). "because of bytecodePrim sends which will either be executed inline
	or send a normal send depending on arguments"! !

!ExtendedProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:47'!
vm

	^ 'ExtendedProfileStackVM'! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 18:58'!
csvExportVars

	^ super csvExportVars 
		addAll: {  
		#byteCodeCounter  . 
		#messageCounter .
		#primitiveCounter . 
		#byteCodesPerSecond .
		#messagesPerSecond .
		#primitivesPerSecond 	
		} asOrderedCollection;
		yourself! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/29/2014 12:46'!
parseOutput

	super parseOutput. "gathers time output"
	successDict := (Compiler evaluate: ((rawOutput findBetweenSubStrs: { '''__SUCCESS__START__' . '__SUCCESS__END__''' }) at: 1)) asDictionary.
	testSuiteSuccess :=  successDict at: #success.
	testResultsSummary := successDict at: #resultsSummary.
	statsDict := (Compiler evaluate: ((rawOutput findBetweenSubStrs: { '__VM_STATS__START__' . '__VM_STATS__END__' }) at: 2)) asDictionary.
	byteCodeCounter := statsDict at: #byteCodeCounter.
	messageCounter := statsDict at: #messageCounter.
	primitiveCounter := statsDict at: #primitiveCounter.! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/15/2014 20:22'!
postProcessing

	super postProcessing.
	byteCodesPerSecond := byteCodeCounter / realTime.
 	primitivesPerSecond := primitiveCounter / realTime.
	messagesPerSecond := messageCounter / realTime.! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/27/2014 15:11'!
sanityCheck

	super sanityCheck.
	self assert: testSuiteSuccess.
	self assert: (byteCodeCounter > messageCounter).
	self assert: (messageCounter > primitiveCounter).! !

!ProfileExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:46'!
vm

	^ 'ProfileStackVM'! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/26/2014 18:26'!
csvExportVars

		^ { #realTime } asOrderedCollection! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/14/2014 21:57'!
parseOutput

	"in seconds"
	
	| timeOutputParsed |
	timeOutputParsed := (rawTimeOutput findBetweenSubStrs: {'real' . 'user' . 'sys'}) collect: [ :str | str trim asNumber ].
	realTime := timeOutputParsed at: 1.
	userTime := timeOutputParsed at: 2.
	systemTime := timeOutputParsed at: 3.
	! !

!VanillaExperimentRun methodsFor: 'accessing' stamp: 'NickPapoulias 6/17/2014 20:45'!
realTime
	^ realTime! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/24/2014 15:32'!
sanityCheck

	super sanityCheck.
	self assert: (realTime > (userTime + systemTime)) | (realTime closeTo: (userTime + systemTime)).! !

!VanillaExperimentRun methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 6/13/2014 12:43'!
vm

	^ 'StackVM'! !
